function [A,AE,ki] = passcountfunction1(pos,ia)
% PASSLINE_COUNT_FUNCTION1 TODO
%
% Inputs:
%   pos: Vessel position matrix
%   ia: TODO
%
% Outputs:
%   A:  Sum of passages across the passline A
%   AE: TODO
%   ki: TODO

%Passline coordinates
A1 = [4.50000,62.39167];
A2 = [5.09843,62.19222];
E1 = [5.54584,62.33473];
E2 = [5.12622,62.02920];

ID = pos(:,1);  %Vessel ID
long = pos(:,2);%longitude
lat = pos(:,3); %latitude
n_v = length(ia); %n vessels
n_m = length(pos); %n messages

% Passline A function
vA = [(A2(2)-A1(2)),(A2(1)-A1(1))];
aA = vA(1)/vA(2);
bA = -aA*(A1(1))+A1(2);

% Passline E function 
vE = [(E2(2)-E1(2)),(E2(1)-E1(1))];
aE = vE(1)/vE(2);
bE = -aE*(E1(1))+E1(2);

k = zeros(n_v,2);

for i = 1:n_v-1
    for j = ia(i)+1:ia(i+1)-1    
        if lat(j-1)< aA*long(j-1)+bA&&lat(j)>=aA*long(j)+bA&&ID(j-1)==ID(j)
            k(i,1) = k(i,1)+1;    
        elseif lat(j-1)>aA*long(j-1)+bA&&lat(j)<=aA*long(j)+bA&&ID(j-1)==ID(j)
            k(i,1) = k(i,1)+1;
        elseif lat(j-1)< aE*long(j-1)+bE&&lat(j)>=aE*long(j)+bE&&ID(j-1)==ID(j)
            k(i,2) = k(i,2)+1;
        elseif lat(j-1)>aE*long(j-1)+bE&&lat(j)<=aE*long(j)+bE&&ID(j-1)==ID(j)
            k(i,2) = k(i,2)+1;
        end
    end
end

% Separate loop for last vessel on list

for h = ia(n_v)+1:n_m
    if lat(h-1)< aA*long(h-1)+bA&&lat(h)>=aA*long(h)+bA&&ID(h-1)==ID(h)
        k(n_v,1) = k(n_v,1)+1;    
    elseif lat(h-1)>aA*long(h-1)+bA&&lat(h)<=aA*long(h)+bA&&ID(h-1)==ID(h)
        k(n_v,1) = k(n_v,1)+1;
    elseif lat(h-1)< aE*long(h-1)+bE&&lat(h)>=aE*long(h)+bE&&ID(h-1)==ID(h)
        k(n_v,2) = k(n_v,2)+1;
    elseif lat(h-1)>aE*long(h-1)+bE&&lat(h)<=aE*long(h)+bE&&ID(h-1)==ID(h)
        k(n_v,2) = k(n_v,2)+1;
    end
end

  

%A and E-passages respectively:
A = sum(k(:,1));
E = sum(k(:,2));

%Passages across both A and E
kae = zeros(length(k),1);


for i = 1:length(k)
    if k(i,1)>k(i,2) 
        kae(i,1) = k(i,2);
        ka(i) = k(i,1)-k(i,2);
    else
        kae(i,1) = k(i,1);
        ka(i) = 0;
    end
end

AE = sum(kae(:,1));
ki = find(ka(:));
%ki=find(kae);

end

